#include <TimerOne.h>
#define stepPin 1
#define dirPin 2
#define CLOCKWISE     HIGH
#define ANTICLOCKWISE LOW
#define STEPS_PER_REV 2000
int dir = CLOCKWISE;  // Clockwise
int state = LOW;

volatile long steps = STEPS_PER_REV *2L;
int ctr = 0;

void setup() 
{
  // Initialize the digital pin as an output.
  // Pin 13 has an LED connected on most Arduino boards
  pinMode(13, OUTPUT);    
  pinMode(stepPin, OUTPUT);
  pinMode(dirPin, OUTPUT);

  Timer1.initialize(40); // set a timer of length in microseconds (or 0.1 sec - or 10Hz
  Timer1.attachInterrupt( timerIsr ); // attach the service routine here
}
 
void loop()
{
  // Main code loop
  // TODO: Put your regular (non-ISR) logic here
    int i;
    if(steps == 0){
      delay(500);
      dir = dir ^ 1;
      digitalWrite( dirPin, dir );    
      if(dir == CLOCKWISE)
          steps = STEPS_PER_REV * 2L;  
      else
          steps = STEPS_PER_REV;
    }

}
 
/// --------------------------
/// Custom ISR Timer Routine
/// --------------------------
void timerIsr()
{
    // Toggle LED
  if(steps){
      digitalWrite( 13, digitalRead( 13 ) ^ 1 );
      state = state ^ 1;
      digitalWrite( stepPin, state );
      steps--;
  }
}
